local _G = _G
local RW = _G.RW3

local expect = RW.Debug.expect
local DEBUG = RW.DEBUG

local Utils = {}
RW.Utils = Utils
function Utils:GUID_CID(guid)
	if DEBUG then
		expect(guid, "typeof", "string")
	end
	
	if not guid then return 0 end
	
	return tonumber(guid:sub(7, 10), 16)
end

do
	local function tabletostring(t) return t._name end
	function Utils:NamedTable(t, name)
		if DEBUG then
			expect(name, "typeof", "string")
		end
		t._name = name
		
		local newMeta = {}
		local oldmeta = getmetatable(t)
		if oldmeta then
			for k, v in pairs(oldmeta) do newMeta[k] = v end
		end
		newMeta.__tostring = tabletostring
		
		setmetatable(t, newMeta)
	end
end

function Utils:IconTexture(icon)
	if DEBUG then
		expect(icon, "typeof", "string")
	end
	return ("Interface\\ICONS\\%s"):format(icon)
end